// ==============================================================
//
//  Copyright (c) 1999-2004 by Alex Vinokur.
//
//  For conditions of distribution and use, see
//  copyright notice in version.h
//
// ==============================================================


// ##############################################################
// ==================================
//  n-ary Huffman Template Algorithm
// ==================================
//
//  FILE : demomain.cpp
//
//  AUTHOR : Alex Vinokur
//
//  DESCRIPTION :
//
//
//         Running the tests
//         -----------------
//
// ##############################################################


// ===================
#include "methods.h"
#include "democase.h"
// ===================


// ==============================
vector<int>  get_adapted_weights (int n, const vector<int>& v)
{
vector<int> ret (v);

  while ((ret.size() - 1)%(n - 1)) ret.push_back(0);
  return ret;

}


// #####################################################
// ############# main ##################################
// #####################################################
// ==============================
int main (int argc, char **argv)
{
vector<int>	inst_vect;

	cout << endl;
	cout << endl;
	cout << "\t------> YOUR COMMAND LINE : ";
	for (int i = 0; i < argc; i++)
	{
		cout <<	argv[i] << " ";
	}
	cout << endl;

	// ----------------------------
	for (int i = 1; i < argc; i++)
	{
		inst_vect.push_back(atoi(argv[i]));
	}

	if (inst_vect.empty())	inst_vect.push_back(1);	


	

	// ----------------------------
	cout << "\t------> TEST GROUPS : ";
	for (count_t i = 0; i < inst_vect.size(); i++)
	{
		cout <<	inst_vect[i] << " ";
	}
	cout << endl;
	cout << endl;

	// ----------------------------
	for (count_t i = 0; i < inst_vect.size(); i++)
	{
	ClassTest test (inst_vect[i]);

		test.DEMO_CASE(t01);
		test.DEMO_CASE(t02);
		test.DEMO_CASE(t03);
		test.DEMO_CASE(t04);
		test.DEMO_CASE(t05);
		test.DEMO_CASE(t06);
		test.DEMO_CASE(t07);
		test.DEMO_CASE(t08);

		test.DEMO_CASE(m01);
		test.DEMO_CASE(m02);
	}

vector<Cell<string, float> >	vect1;

        vect1.push_back (Cell<string, float> ("a", 0.45));
        vect1.push_back (Cell<string, float> ("b", 0.35));
        vect1.push_back (Cell<string, float> ("c", 0.20));

LoadedHuffmanTree<string, float, 2>         tree1 (vect1);
        tree1.showAll ("Extra-Test-1 : Creating Loaded Binary Huffman Tree from <string, float>-data vector");



vector<Cell<string, float> >	vect2;

        vect2.push_back (Cell<string, float> ("a", 0.15));
        vect2.push_back (Cell<string, float> ("b", 0.05));
        vect2.push_back (Cell<string, float> ("c", 0.20));
        vect2.push_back (Cell<string, float> ("ab", 0.30));

LoadedHuffmanTree<string, float, 2>         tree2 (vect2);
        tree2.showAll ("Extra-Test-2 : Creating Loaded Binary Huffman Tree from <string, float>-data vector");


	// ----------------------------
vector<int>	weights;
	weights.push_back(1);
	weights.push_back(1);
	weights.push_back(2);
	weights.push_back(3);
	weights.push_back(5);
	weights.push_back(8);
	weights.push_back(13);
	weights.push_back(1);

DriedHuffmanTree<int, 2>   tree_binary (weights);
        tree_binary.showAll ("Extra-Test-3.1 : Creating Dried Binary Huffman Tree");

DriedHuffmanTree<int, 4>   tree_4_ary (get_adapted_weights (4, weights));
        tree_4_ary.showAll ("Extra-Test-3.2 : Creating Dried 4-ary Huffman Tree");

DriedHuffmanTree<int, 8>   tree_8_ary (get_adapted_weights (8, weights));
        tree_8_ary.showAll ("Extra-Test-3.3 : Creating Dried 8-ary Huffman Tree");



} // main


// #######################################################
// ################ END OF FILE ##########################
// #######################################################

