// ==============================================================
//
//  Copyright (c) 1999-2004 by Alex Vinokur.
//
//  For conditions of distribution and use, see
//  copyright notice in version.h
//
// ==============================================================

///////////////////////////////////////

#ifndef DEMOTYPE_H
#define DEMOTYPE_H

///////////////////////////////////////


// ##############################################################
// ==================================
//  n-ary Huffman Template Algorithm
// ==================================
//
//  FILE : demotype.h
//
//  AUTHOR : Alex Vinokur
//
//  DESCRIPTION :
//
//         Definition of the following test classes :
//         ----------------------------------------------
//         - AAA        (non-char) symbol type
//         - BBB        (non-numerical) weight type
//         ----------------------------------------------
//
// ##############################################################


// =======================
#include <iostream>
using namespace std;
// =======================



// ###################################################
// ############## "Symbols" Test Class ###############
// ###################################################
class AAA
{
friend bool operator< (const AAA& inst1_i, const AAA& inst2_i);
friend ostream& operator<< (ostream& o, const AAA& instance_i);
        private :
                static unsigned int     counter_s;
                unsigned int            counter_;
        public :
                AAA ();
                ~AAA () {}
};


// ###################################################
// ############## "Weight" Test Class ################
// ###################################################
class BBB
{
friend ostream& operator<< (ostream& o, const BBB& instance_i);
friend bool operator< (const BBB& inst1_i, const BBB& inst2_i);
friend bool operator== (const BBB& inst1_i, const BBB& inst2_i);
friend BBB operator* (const BBB& inst1_i, unsigned int int_value_i);
friend BBB operator/ (const BBB& inst1_i, unsigned int int_value_i);
        private :
                int                     value_;
                static unsigned int     counter_s;
                unsigned int            counter_;

        public :
                BBB ();
                ~BBB () {}
                BBB& operator+= (const BBB& inst_i);

};


#endif	// DEMOTYPE_H

// #######################################################
// ################ END OF FILE ##########################
// #######################################################

